// misc.sp

stock FakePrecacheSound( const String:szPath[] )
{
	AddToStringTable( FindStringTable( "soundprecache" ), szPath );
}

stock Client_SetScore(client, value)
{
	SetEntProp(client, Prop_Data, "m_iFrags", value);
}

stock Client_SetDeaths(client, value)
{
	SetEntProp(client, Prop_Data, "m_iDeaths", value);
}

stock Client_SetAssists(client, value)
{
	new assists_offset = FindDataMapOffs( client, "m_iFrags" ) + ASSISTS_OFFSET_FROM_FRAGS; 
	SetEntData(client, assists_offset, value );
}

public SetStandingStartButton(client)
{	
	CreateButton(client,"climb_startbutton");
}

public SetStandingStopButton(client)
{
	CreateButton(client,"climb_endbutton");
}

public GiveWeaponFunc(client,String:k[]) 
{	
	if (g_bPluginEnabled)
	{
		new removeWeapons;	
		for (new i = 0; i < 6; i++)
			if (i < 6 && (removeWeapons = GetPlayerWeaponSlot(client, i)) != -1) 
				RemovePlayerItem(client, removeWeapons);
		GivePlayerItem(client, k);			
	}
}

public Action:BlockRadio(client, const String:command[], args) 
{
	if(!g_bRadioCommands && g_bPluginEnabled)
	{
		PrintToChat(client, "%t", "RadioCommandsDisabled", LIMEGREEN,WHITE);
		return Plugin_Handled;
	}
	return Plugin_Continue;
}

public DeleteButtons(client)
{
	new ent = -1;
	while ((ent = FindEntityByClassname(ent, "prop_physics_override")) != -1)
	{
		if (IsValidEntity(ent))
		{
			decl String:targetname[64];
			GetEntPropString(ent, Prop_Data, "m_iName", targetname, sizeof(targetname));
			if (StrEqual(targetname, "climb_startbutton", false) || StrEqual(targetname, "climb_endbutton", false))
			{
				AcceptEntityInput(ent, "Kill"); 
				RemoveEdict(ent);
			}
		}
		g_bMapButtons=false;
	}
	KzAdminMenu(client);	
}


public KnifeMenu(client) 
{	
	if (g_bPluginEnabled==false) return;
	new Handle:menu = CreateMenu(KnifeMenuHandler);
	SetMenuTitle(menu, "Choose knife skin");
	AddMenuItem(menu, "Standard knife", "Standard");
	AddMenuItem(menu, "give weapon_knife_gut", "Gut");
	AddMenuItem(menu, "give weapon_knife_karambit", "Karambit");
	AddMenuItem(menu, "give weapon_bayonet", "Bayonet");
	AddMenuItem(menu, "give weapon_flip", "Flip");
	AddMenuItem(menu, "give weapon_flip", "M9 Bayonet");
	SetMenuOptionFlags(menu, MENUFLAG_BUTTON_EXIT);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public KnifeMenuHandler(Handle:menu, MenuAction:action, param1,param2)
{
	if(action == MenuAction_Select)
	{
			switch(param2)
			{
				case 0: GiveWeaponFunc(param1,"weapon_knife");
				case 1: GiveWeaponFunc(param1,"weapon_knife_gut");
				case 2: GiveWeaponFunc(param1,"weapon_knife_karambit");
				case 3: GiveWeaponFunc(param1,"weapon_bayonet");
				case 4: GiveWeaponFunc(param1,"weapon_knife_flip");
				case 5: GiveWeaponFunc(param1,"weapon_knife_m9_bayonet");
			}
			KnifeMenu(param1);
	}
	else
	if(action == MenuAction_Cancel)
	{
		OptionMenu(param1);
	}
	else if (action == MenuAction_End)
	{	
		CloseHandle(menu);
	}
}
public CreateButton(client,String:targetname[]) 
{
	if (IsPlayerAlive(client))
	{
		//location (crosshair)
		new Float:locationPlayer[3];
		new Float:location[3];
		GetClientAbsOrigin(client, locationPlayer);
		GetClientEyePosition(client, location);
		new Float:ang[3];
		GetClientEyeAngles(client, ang);
		new Float:location2[3];
		location2[0] = (location[0]+(100*((Cosine(DegToRad(ang[1]))) * (Cosine(DegToRad(ang[0]))))));
		location2[1] = (location[1]+(100*((Sine(DegToRad(ang[1]))) * (Cosine(DegToRad(ang[0]))))));
		ang[0] -= (2*ang[0]);
		location2[2] = (location[2]+(100*(Sine(DegToRad(ang[0])))));
		location2[2] = locationPlayer[2];
	
		new ent = CreateEntityByName("prop_physics_override");
		if (ent != -1)
		{  
			DispatchKeyValue(ent, "model", "models/kzmod/buttons/standing_button.mdl");
			DispatchKeyValue(ent, "spawnflags", "264");
			DispatchKeyValue(ent, "targetname",targetname);
			DispatchSpawn(ent);   
			TeleportEntity(ent, location2, NULL_VECTOR, NULL_VECTOR);
			SDKHook(ent, SDKHook_UsePost, OnUsePost);				
			PrintToChat(client,"%c[%cKZ%c] %s created", WHITE,MOSSGREEN,WHITE,targetname);
			g_bMapButtons=true;
			//DB 
			if (StrEqual(targetname, "climb_startbutton"))
				db_updateMapButtons(location2[0],location2[1],location2[2],0);
			else
				db_updateMapButtons(location2[0],location2[1],location2[2],1);
		}
		
		
	}
	else
		PrintToChat(client, "%t", "AdminSetButton", MOSSGREEN,WHITE); 
	KzAdminMenu(client);
}

// - Get Runtime -
public GetcurrentRunTime(client)
{
	g_fRunTime[client] = GetEngineTime() - g_fStartTime[client] - g_fPauseTime[client];					
	FormatTimeFloat(client, g_fRunTime[client], 1);
	
	if(StrEqual(g_szPlayerPanelText[client],""))		
		Format(g_szMenuTitleRun[client], 255, "%s", g_szTime[client]);
	else
		Format(g_szMenuTitleRun[client], 255, "%s\n%s", g_szPlayerPanelText[client],g_szTime[client]);
}

public Float:GetSpeed(client)
{
	decl Float:fVelocity[3];
	GetEntPropVector(client, Prop_Data, "m_vecVelocity", fVelocity);
	new Float:speed = SquareRoot(Pow(fVelocity[0],2.0)+Pow(fVelocity[1],2.0));
	return speed;
}

public Float:GetVelocity(client)
{
	decl Float:fVelocity[3];
	GetEntPropVector(client, Prop_Data, "m_vecVelocity", fVelocity);
	new Float:speed = SquareRoot(Pow(fVelocity[0],2.0)+Pow(fVelocity[1],2.0)+Pow(fVelocity[2],2.0));
	return speed;
}

public PlayLeetJumpSound(client)
{
	decl String:buffer[255];	

	//all sound
	if (g_LeetJumpDominating[client] == 3 && g_LeetJumpDominating[client] == 5)
	{
		for (new i = 1; i <= MaxClients; i++)
		{ 
			if(IsClientInGame(i) && !IsFakeClient(i) && i != client && g_bColorChat[i] && g_bEnableQuakeSounds[i])
			{	
					if (g_LeetJumpDominating[client]==3)
					{
						Format(buffer, sizeof(buffer), "play %s", LEETJUMP_RAMPAGE_RELATIVE_SOUND_PATH); 	
						ClientCommand(i, buffer); 
					}
					else
						if (g_LeetJumpDominating[client]==5)
						{
							Format(buffer, sizeof(buffer), "play %s", LEETJUMP_DOMINATING_RELATIVE_SOUND_PATH); 		
							ClientCommand(i, buffer); 
						}
			}
		}
	}
	
	//client sound
	if 	(IsClientInGame(client) && !IsFakeClient(client) && g_bEnableQuakeSounds[client] == true)
	{
		if (g_LeetJumpDominating[client] == 1)
		{
			Format(buffer, sizeof(buffer), "play %s", LEETJUMP_RELATIVE_SOUND_PATH); 
			ClientCommand(client, buffer); 
		}
			else
			if (g_LeetJumpDominating[client]==3)
			{
				Format(buffer, sizeof(buffer), "play %s", LEETJUMP_RAMPAGE_RELATIVE_SOUND_PATH); 	
				ClientCommand(client, buffer); 
			}
			else
			if (g_LeetJumpDominating[client]==5)
			{
				Format(buffer, sizeof(buffer), "play %s", LEETJUMP_DOMINATING_RELATIVE_SOUND_PATH); 		
				ClientCommand(client, buffer); 
			}					
	}
}

public EnableKzMod()
{
	g_bPluginEnabled = true;
	OnMapStart();
	if (g_bEnforcer==true)
	{
		for(new i = 1; i <= GetMaxClients(); i++) 
		{ 
			if(IsClientInGame(i) && !IsFakeClient(i)) 
			{ 
					PrintToChat(i, "%t", "SettingsEnforcerEnabled", MOSSGREEN,WHITE,LIMEGREEN);
			}
		}
	}
	else
	{
		for(new i = 1; i <= GetMaxClients(); i++) 
		{ 
			if(IsClientInGame(i) && !IsFakeClient(i)) 
			{
					PrintToChat(i, "%t", "SettingsEnforcerDisabled", MOSSGREEN,WHITE);
			}
		}	
	}

	new removeWeapons;
	for(new i = 1; i <= MAXPLAYERS; i++)
	{
		if (1 <= i <= MaxClients && IsValidEntity(i) && IsClientInGame(i))
		{
			OnClientPostAdminCheck(i);
			if (IsPlayerAlive(i) && g_bCleanWeapons==true)
			{
				for (new j = 0; j < 6; j++)
					if (j < 6 && (removeWeapons = GetPlayerWeaponSlot(i, j)) != -1) 		
						RemovePlayerItem(i, removeWeapons);
				GivePlayerItem(i, "weapon_knife");
			}	
		}
	}
}

public SetCashState()
{
	ServerCommand("mp_startmoney 0; mp_playercashawards 0; mp_teamcashawards 0");
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientConnected(i) && IsClientInGame(i))
			SetEntProp(i, Prop_Send, "m_iAccount", 0);
	}
}

public PlayRecordSound(iRecordtype)
{
	decl String:buffer[255];
	if (iRecordtype==1)
	    for(new i = 1; i <= GetMaxClients(); i++) 
		{ 
			if(IsClientInGame(i) && !IsFakeClient(i) && g_bEnableQuakeSounds[i] == true) 
			{ 
				Format(buffer, sizeof(buffer), "play %s", PRO_RELATIVE_SOUND_PATH); 
				ClientCommand(i, buffer); 
			}
		} 
	else
		if (iRecordtype==2 || iRecordtype == 3)
			for(new i = 1; i <= GetMaxClients(); i++) 
			{ 
				if(IsClientInGame(i) && !IsFakeClient(i) && g_bEnableQuakeSounds[i] == true) 
				{ 
					Format(buffer, sizeof(buffer), "play %s", CP_RELATIVE_SOUND_PATH); 
					ClientCommand(i, buffer); 
				}
			}
}

public InitPrecache()
{
	AddFileToDownloadsTable( PRO_FULL_SOUND_PATH );
	FakePrecacheSound( PRO_RELATIVE_SOUND_PATH );	
	AddFileToDownloadsTable( CP_FULL_SOUND_PATH );
	FakePrecacheSound( CP_RELATIVE_SOUND_PATH );
	AddFileToDownloadsTable( PRO_FULL_SOUND_PATH );
	FakePrecacheSound( PRO_RELATIVE_SOUND_PATH );	
	AddFileToDownloadsTable( LEETJUMP_FULL_SOUND_PATH );
	FakePrecacheSound( LEETJUMP_RELATIVE_SOUND_PATH );
	AddFileToDownloadsTable( LEETJUMP_DOMINATING_FULL_SOUND_PATH );
	FakePrecacheSound( LEETJUMP_DOMINATING_RELATIVE_SOUND_PATH );
	AddFileToDownloadsTable( LEETJUMP_RAMPAGE_FULL_SOUND_PATH );
	FakePrecacheSound( LEETJUMP_RAMPAGE_RELATIVE_SOUND_PATH );
	AddFileToDownloadsTable( PROJUMP_FULL_SOUND_PATH );
	FakePrecacheSound( PROJUMP_RELATIVE_SOUND_PATH );
	AddFileToDownloadsTable("models/kzmod/buttons/standing_button.mdl");
	AddFileToDownloadsTable("models/kzmod/buttons/standing_button.vvd");
	AddFileToDownloadsTable("models/kzmod/buttons/standing_button.phy");
	AddFileToDownloadsTable("models/kzmod/buttons/standing_button.dx90.vtx");	
	AddFileToDownloadsTable("models/kzmod/buttons/stand_button.vmt");
	AddFileToDownloadsTable("models/kzmod/buttons/stand_button.vtf");
	AddFileToDownloadsTable("models/kzmod/buttons/stand_button_normal.vtf");
	PrecacheModel("models/kzmod/buttons/standing_button.mdl");
	PrecacheSound("buttons/blip1.wav", true);
	PrecacheSound("buttons/button3.wav", true);
	PrecacheSound("buttons/button10.wav", true);
}

// thx to V952 https://forums.alliedmods.net/showthread.php?t=212886
stock TraceClientViewEntity(client)
{
	new Float:m_vecOrigin[3];
	new Float:m_angRotation[3];
	GetClientEyePosition(client, m_vecOrigin);
	GetClientEyeAngles(client, m_angRotation);
	new Handle:tr = TR_TraceRayFilterEx(m_vecOrigin, m_angRotation, MASK_VISIBLE, RayType_Infinite, TRDontHitSelf, client);
	new pEntity = -1;
	if (TR_DidHit(tr))
	{
		pEntity = TR_GetEntityIndex(tr);
		CloseHandle(tr);
		return pEntity;
	}
	CloseHandle(tr);
	return -1;
}

// thx to V952 https://forums.alliedmods.net/showthread.php?t=212886
public bool:TRDontHitSelf(entity, mask, any:data)
{
 if (entity == data) return false;
 return true;
}

public PrintMapRecords(client)
{
			if (g_fRecordTimeGlobal != 9999999.0)
			{
				FormatTimeFloat(client, g_fRecordTimeGlobal, 3);
				PrintToChat(client, "[%cKZ%c] %cGLOBAL RECORD%c: %s (%s)",MOSSGREEN,WHITE,RED,WHITE, g_szTime[client], g_szRecordGlobalPlayer); 
			}	
			if (g_fRecordTimePro != 9999999.0)
			{
				FormatTimeFloat(client, g_fRecordTimePro, 3);
				PrintToChat(client, "[%cKZ%c] %cPRO RECORD%c: %s (%s)",MOSSGREEN,WHITE,PURPLE,WHITE, g_szTime[client], g_szRecordPlayerPro); 
			}	
			if (g_fRecordTime != 9999999.0)
			{
				FormatTimeFloat(client, g_fRecordTime, 3);
				PrintToChat(client, "[%cKZ%c] %cTP RECORD%c: %s (%s)",MOSSGREEN,WHITE,YELLOW,WHITE, g_szTime[client], g_szRecordPlayer); 
			}	
}

public FormatTimeFloat(client, Float:time, type)
{
	decl String:szMilli[16];
	decl String:szSeconds[16];
	decl String:szMinutes[16];
	decl String:szHours[16];
	new imilli;
	new iseconds;
	new iminutes;
	new ihours;
	time = FloatAbs(time);
	imilli = RoundToZero(time*100);
	imilli = imilli%100;
	iseconds = RoundToZero(time);
	iseconds = iseconds%60;	
	iminutes = RoundToZero(time/60);	
	iminutes = iminutes%60;	
	ihours = RoundToZero((time/60)/60);

	if (imilli < 10)
		Format(szMilli, 16, "0%dms", imilli);
	else
		Format(szMilli, 16, "%dms", imilli);
	if (iseconds < 10)
		Format(szSeconds, 16, "0%ds", iseconds);
	else
		Format(szSeconds, 16, "%ds", iseconds);
	if (iminutes < 10)
		Format(szMinutes, 16, "0%dm", iminutes);
	else
		Format(szMinutes, 16, "%dm", iminutes);	
	if (type==1)
	{
		Format(szHours, 16, "%dm", iminutes);	
		if (ihours>0)	
		{
			Format(szHours, 16, "%dh", ihours);
			Format(g_szTime[client], 32, "%s %s %s %s", szHours, szMinutes,szSeconds,szMilli);
		}
		else
			Format(g_szTime[client], 32, "%s %s %s", szMinutes,szSeconds,szMilli);	
	}
	else
	if (type==2)
	{
		imilli = RoundToZero(time*1000);
		imilli = imilli%1000;
		if (imilli < 10)
			Format(szMilli, 16, "00%dms", imilli);
		else
		if (imilli < 100)
			Format(szMilli, 16, "0%dms", imilli);
		else
			Format(szMilli, 16, "%dms", imilli);
		Format(szHours, 16, "%dh", ihours);
		Format(g_szTime[client], 32, "%s %s %s %s",szHours, szMinutes,szSeconds,szMilli);
	}
	else
	if (type==3)
	{
		if (imilli < 10)
			Format(szMilli, 16, "0%d", imilli);
		else
			Format(szMilli, 16, "%d", imilli);
		if (iseconds < 10)
			Format(szSeconds, 16, "0%d", iseconds);
		else
			Format(szSeconds, 16, "%d", iseconds);
		if (iminutes < 10)
			Format(szMinutes, 16, "0%d", iminutes);
		else
			Format(szMinutes, 16, "%d", iminutes);	
		if (ihours>0)	
		{
			Format(szHours, 16, "%d", ihours);
			Format(g_szTime[client], 32, "%s:%s:%s.%s", szHours, szMinutes,szSeconds,szMilli);
		}
		else
			Format(g_szTime[client], 32, "%s:%s.%s", szMinutes,szSeconds,szMilli);	
	}
}