// timer.sp

public Action:RefreshAdminMenu(Handle:timer, any:client)
{
	if (IsValidEntity(client) && !IsFakeClient(client))
		KzAdminMenu(client);
}

public Action:DBUpdateTimer(Handle:timer, any:client)
{
	if (IsClientInGame(client))
	{
		db_updateStat(client);	
		decl String:szSteamId[32];
		GetClientAuthString(client, szSteamId, 32);
		db_deleteTmp(client, szSteamId, g_szMapName);
	}
}

public Action:RefreshPoints(Handle:timer, any:client)
{
	db_updateStat(client);	
}


public Action:RespawnTimer(Handle:timer)
{
	if (g_bPluginEnabled)
	{
		//Player Respawn
		for (new client = 1; client <= MaxClients; client++)
		{	
			if (IsClientInGame(client) && !IsPlayerAlive(client) && (GetClientTeam(client) > 1) && !g_bSpectate[client] && g_bAutoRespawn)	
			{									
				CreateTimer(1.0, RespawnPlayer, client);
			}
		}
	}
}

public Action:OnDeathTimer(Handle:Timer, any:client)
{
	if (IsClientInGame(client) && g_bPluginEnabled == true)
	{
		new team = GetClientTeam(client);
		if ( team != 1)
		{	
			if (g_bTeleMenuOpen[client])
				g_bTeleMenuOpen2[client] = true;
			
			//kill timer
			if (g_bTimeractivated[client] && (GetClientTeam(client) > 1)  && !g_bSpectate[client])
			{
				g_bTimeractivated[client] = false;
				g_fStartTime[client] = -1.0;
				g_fRunTime[client] = 0.0;
			}		
		}
	}
}

//Timer_Starter: Thx to AL-KINDA :-)
public Action:Timer_Countdown(Handle:timer, any:client)
{
	if (g_bPluginEnabled)
	{
		PrintToChat(client,"[%cKZ%c] %c%i",RED,WHITE,YELLOW,g_CountdownTime[client]);
		g_CountdownTime[client]--;
		if(g_CountdownTime[client] <= 0) 
		{
			SetEntityMoveType(client, MOVETYPE_WALK);
			PrintToChat(client, "%t", "ChallengeStarted1",RED,WHITE,YELLOW);
			PrintToChat(client, "%t", "ChallengeStarted2",RED,WHITE,YELLOW);
			PrintToChat(client, "%t", "ChallengeStarted3",RED,WHITE,YELLOW);
			KillTimer(timer);
			//Timer_Starter(client); // REASON: COULD FALSIFY MAP RECORDS BECAUSE OF SPAWN POSITIONS WHICH ARE BETTER POSITIONED TO THE FIRST BLOCK THAN THE START BUTTON
		}
	}
}

//Timer_Starter: Thx to AL-KINDA :-)
/*public Action:Timer_Starter(client)
{
	if (g_bPluginEnabled)
	{
		//start that timer!
		//Get SteamID
		decl String:szSteamId[32];
		GetClientAuthString(client, szSteamId, 32);
	
		//set run variables
		g_CurrentCp[client] = -1;
		g_CounterCp[client] = 0;	
		g_OverallCp[client] = 0;
		g_OverallTp[client] = 0;
		g_fPauseTime[client] = 0.0;
		g_fStartPauseTime[client] = 0.0;
		g_bPause[client] = false;
		SetEntityMoveType(client, MOVETYPE_WALK);
		SetEntityRenderMode(client, RENDER_NORMAL);

		//DB
		db_setTmpDataRecord(client, szSteamId, g_szMapName);
		
		//Start time
		g_fStartTime[client] = GetEngineTime();
			
		g_bMenuOpen[client] = false;		
		g_bTopMenuOpen[client]=false;	
		g_bTimeractivated[client] = true;
		g_bPlayerJumped[client] = false;
		g_bNoClip[client] = false;
		return Plugin_Handled;	
	}
}*/

public Action:CheckChallenge(Handle:timer, any:client)
{
	new bool:oppenent=false;
	decl String:szSteamId[32];
	if (g_bChallenge[client] && g_bPluginEnabled)
	{
		for (new i = 1; i <= MaxClients; i++)
		{
			if (IsClientInGame(i) && i != client)
			{	
				GetClientAuthString(i, szSteamId, 32);		
					if (StrEqual(szSteamId,g_szCOpponentID[client]))
						oppenent=true;
			}
		}
		if (!oppenent)
		{
			g_bChallenge[client]=false;
			g_pr_multiplier[client]+=g_CBet[client];
			g_pr_showmsg[client] = true;
			if (g_CBet[client]>0)
			{
				CalculatePlayerRank(client);
				db_selectRankedPlayer(g_szCOpponentID[client], g_CBet[client]);
			}
			if (IsClientInGame(client))
				PrintToChat(client, "%t", "ChallengeWon",RED,WHITE,YELLOW,WHITE);
			KillTimer(timer);
		}
	}
	else
		KillTimer(timer);
}

public Action:ServerTimer(Handle:timer)
{
	if (g_bPluginEnabled)
	{
		//Server settings enforcer
		if (g_bEnforcer)		
			ServerCommand("bot_quota 0;kz_prespeed_cap 380.0;sv_staminalandcost 0;sv_maxspeed 320; sv_staminajumpcost 0; sv_gravity 800; sv_airaccelerate 100; sv_friction 4.8;sv_accelerate 6.5;sv_maxvelocity 2000;sv_cheats 0"); 
	}
	return Plugin_Continue;
}

public Action:ClientTimer(Handle:timer)
{
	if (g_bPluginEnabled)
	{
		for (new client = 1; client <= MaxClients; client++)
		{		

			//speedmeter & playernames & challenge check
		    if(IsClientConnected(client) && IsClientInGame(client) && IsPlayerAlive(client))
			{						
				if (g_bChallengeRequest[client])
				{
					new Float:time= GetEngineTime() - g_fChallengeRequestTime[client];
					if (time>20.0)
					{
						PrintToChat(client, "%t", "ChallengeRequestExpired", RED,WHITE,YELLOW);
						g_bChallengeRequest[client] = false;
					}
				}		
			}
	
			//Spectator list player
			Format(g_szPlayerPanelText[client], 512, "");
			if (IsClientInGame(client) && IsPlayerAlive(client))
			{
				decl String:sSpecs[512];
				new SpecMode;
				Format(sSpecs, 512, "");
				new count=0;
				for(new i = 1; i <= MaxClients; i++) 
				{
					if (IsClientInGame(i) && !IsPlayerAlive(i) && GetClientTeam(i) >= 1 && GetClientTeam(i) <= 3)
					{			
						SpecMode = GetEntProp(i, Prop_Send, "m_iObserverMode");
						if (SpecMode == 4 || SpecMode == 5)
						{		
							new Target = GetEntPropEnt(i, Prop_Send, "m_hObserverTarget");	
							if (Target == client)
							{
								count++;
								if (count < 6)
								Format(sSpecs, 512, "%s%N\n", sSpecs, i);
			
							}	
							if (count ==5)
								Format(sSpecs, 512, "%s...", sSpecs);
						}					
					}		
				}	
				if (count > 0)
				{
					Format(g_szPlayerPanelText[client], 512, "Specs (%i):\n%s ", count, sSpecs);
					SpecList(client);
				}
				else
					Format(g_szPlayerPanelText[client], 512, "");	
			}		
			
			//Spectator list spec + showkeys
			if (IsClientInGame(client) && !IsPlayerAlive(client))
			{
				decl String:sSpecs[512];
				Format(sSpecs, 512, "");
				new SpecMode;			
				SpecMode = GetEntProp(client, Prop_Send, "m_iObserverMode");	
				if (SpecMode == 4 || SpecMode == 5)
				{
					new	ObservedUser = GetEntPropEnt(client, Prop_Send, "m_hObserverTarget");	
					new count=0;
					//Speclist
					if (1 <= ObservedUser <= MaxClients)
					{
						for(new x = 1; x <= MaxClients; x++) 
						{					
							if (IsClientInGame(x) && IsValidEntity(x) && !IsPlayerAlive(x) && GetClientTeam(x) >= 1 && GetClientTeam(x) <= 3)
							{
							
									SpecMode = GetEntProp(x, Prop_Send, "m_iObserverMode");	
									if (SpecMode == 4 || SpecMode == 5)
									{				
									new ObservedUser2 = GetEntPropEnt(x, Prop_Send, "m_hObserverTarget");
									if (ObservedUser == ObservedUser2)
									{
										count++;
										if (count < 6)
										Format(sSpecs, 512, "%s%N\n", sSpecs, x);					
									}	
									if (count ==5)
										Format(sSpecs, 512, "%s...", sSpecs);	
								}
							}					
						}
						if(!StrEqual(sSpecs,""))
						{
							decl String:szName[MAX_NAME_LENGTH];
							GetClientName(ObservedUser, szName, MAX_NAME_LENGTH);
							if (g_bTimeractivated[ObservedUser] == true && g_bShowTime[client] == true)
							{
								decl String:szTime[32];
								decl String:szTPBest[32];
								decl String:szProBest[32];
								decl String:szMilli[6];
								decl String:szSeconds[4];
								new Float:Time = GetEngineTime() - g_fStartTime[ObservedUser] - g_fPauseTime[ObservedUser];
								FormatTimeFloat(client, Time, 1);
								Format(szTime, 32, "%s", g_szTime[client]);	
								
								if (!g_bPause[ObservedUser])
								{
									
									if (g_fPersonalRecord[ObservedUser] > 0.0)
									{	
										FormatTimeFloat(client, g_fPersonalRecord[ObservedUser], 3);
										Format(szTPBest, 32, "%s", g_szTime[client]);	
									}	
									else
										Format(szTPBest, 32, "None");	
									if (g_fPersonalRecordPro[ObservedUser] > 0.0)
									{
										FormatTimeFloat(client, g_fPersonalRecordPro[ObservedUser], 3);
										Format(szProBest, 32, "%s", g_szTime[client]);		
									}
									else
										Format(szProBest, 32, "None");	
									Format(g_szPlayerPanelText[client], 512, "Specs (%i):\n%s\n  \n%s\nTeleports: %i\n \nPersonal Bests\nPro: %s\nTP: %s", count, sSpecs, szTime,g_OverallTp[ObservedUser],szProBest,szTPBest);
								}
								else
									Format(g_szPlayerPanelText[client], 512, "Specs (%i):\n%s\n  \nPAUSE", count, sSpecs);
							}
							else
								Format(g_szPlayerPanelText[client], 512, "Specs (%i):\n%s", count, sSpecs);									
							g_bTeleMenuOpen[client] = false;	
							
							SpecList(client);
						}
					}
					//Showkeys
					if (g_bShowKeys[client]==true)
					{
						decl String:sResult[256];
				
						new Buttons;
						if (1 <= ObservedUser <= MaxClients)
							Buttons = g_ButtonsPressed[ObservedUser];
						if(Buttons & IN_FORWARD)
							Format(sResult, sizeof(sResult), "     W     ");
						else
							Format(sResult, sizeof(sResult), "     -     ");			
						if(Buttons & IN_JUMP)
							Format(sResult, sizeof(sResult), "%s     JUMP\n", sResult);
						else
							Format(sResult, sizeof(sResult), "%s     _   \n", sResult);			
						if(Buttons & IN_MOVELEFT)
							Format(sResult, sizeof(sResult), "%s  A", sResult);
						else
							Format(sResult, sizeof(sResult), "%s  -", sResult);				
						if(Buttons & IN_BACK)
							Format(sResult, sizeof(sResult), "%s  S", sResult);
						else
							Format(sResult, sizeof(sResult), "%s  -", sResult);				
						if(Buttons & IN_MOVERIGHT)
							Format(sResult, sizeof(sResult), "%s  D", sResult);
						else
							Format(sResult, sizeof(sResult), "%s  -", sResult);			
						if(Buttons & IN_DUCK)
							Format(sResult, sizeof(sResult), "%s       DUCK\n", sResult);
						else
						Format(sResult, sizeof(sResult), "%s       _   \n", sResult);				
						if(Buttons & IN_SPEED)
							Format(sResult, sizeof(sResult), "%sWALK", sResult);
						else
							Format(sResult, sizeof(sResult), "%s_   ", sResult);	
						if(Buttons & IN_USE)
							Format(sResult, sizeof(sResult), "%s    USE", sResult);
						else
							Format(sResult, sizeof(sResult), "%s    _  ", sResult);	
						if(Buttons & IN_SCORE) //x
							Format(sResult, sizeof(sResult), "%s         \n", sResult);
						else
							Format(sResult, sizeof(sResult), "%s         \n", sResult);			
						if(Buttons & IN_ATTACK)
							Format(sResult, sizeof(sResult), "%sMOUSE1", sResult);
						else
							Format(sResult, sizeof(sResult), "%s_     ", sResult);			
						if(Buttons & IN_ATTACK2)
							Format(sResult, sizeof(sResult), "%s  MOUSE2", sResult);
						else
							Format(sResult, sizeof(sResult), "%s  _     ", sResult);	
						PrintHintText(client,"%s",sResult);
					}			
				}					
			}
			
			//NAME
			if(IsClientInGame(client) && IsPlayerAlive(client))
			{		
				new target = TraceClientViewEntity(client);
				if (IsValidEdict(target) && !g_bHide[client] && g_bShowNames[client] && target > 0 && target <= MaxClients)
				{
					new clientteam = GetClientTeam(client);
					new targetteam = GetClientTeam(target);
					if (clientteam != targetteam)
					{
						new String:clientName[32];
						GetClientName(target, clientName, sizeof(clientName));
						PrintHintText(client, " \n%s | %s (%d HP)", g_pr_rankname[target], clientName, GetClientHealth(target));   
					}
				}
				else
					if (g_bSpeedMeter[client] && !g_bPause[client])			
						PrintHintText(client,"Last Jump: %.f units\n%.1f units/second\n     %.1f velocity",g_fLastJumpDistance[client],GetSpeed(client),GetVelocity(client));				
			}
		}					
	}
	return Plugin_Continue;		
}

public Action:Connected(Handle:timer, any:client)
{
	if (g_bEnforcer == true)
		PrintToChat(client, "%t", "SettingsEnforcerEnabled", MOSSGREEN,WHITE,LIMEGREEN);
	else
	PrintToChat(client, "%t", "SettingsEnforcerDisabled", MOSSGREEN,WHITE);	
	PrintToChat(client, "%t", "HelpText", MOSSGREEN,WHITE,LIMEGREEN,WHITE);
	g_bMapStart[client] = false;
		
	//display map records
	PrintMapRecords(client);

	if (g_bRestoreCMsg[client]==true)
		PrintToChat(client, "%t", "PositionRestored", MOSSGREEN,WHITE,GRAY);
	g_bRestoreCMsg[client]=false;
	//PrintToChat(client, "[%cKZ EUROPE%c] %cEnglish%c is the only language spoken on this server.", GRAY,WHITE, GREEN, LIMEGREEN);
	TeleMenu(client);
			
}

public Action:SetClanTag(Handle:timer, any:client)
{
	if (client > MaxClients || client < 1 || !IsValidEntity(client) || !IsClientInGame(client) || !g_bPointSystem)
		return;
		
	decl String:old_pr_rankname[32];  
	new bool:oldrank;
	
	if (!StrEqual(g_pr_rankname[client], "", false))
	{
		oldrank=true;
		Format(old_pr_rankname, 32, "%s", g_pr_rankname[client]); 
	}
	
	if (g_pr_points[client] < g_pr_rank_Novice)
		Format(g_pr_rankname[client], 32, "UNRANKED");
	else					
	if (g_pr_rank_Novice <= g_pr_points[client] && g_pr_points[client] < g_pr_rank_Scrub)
		Format(g_pr_rankname[client], 32, "NOVICE");
	else
	if (g_pr_rank_Scrub <= g_pr_points[client] && g_pr_points[client] < g_pr_rank_Rookie)
		Format(g_pr_rankname[client], 32, "SCRUB");
	else
	if (g_pr_rank_Rookie <= g_pr_points[client] && g_pr_points[client] < g_pr_rank_Skilled)
		Format(g_pr_rankname[client], 32, "ROOKIE");
	else
	if (g_pr_rank_Skilled <= g_pr_points[client] && g_pr_points[client] < g_pr_rank_Expert)
		Format(g_pr_rankname[client], 32, "SKILLED");
	else
	if (g_pr_rank_Expert <= g_pr_points[client] && g_pr_points[client] < g_pr_rank_Pro)
		Format(g_pr_rankname[client], 32, "EXPERT");
	else
	if (g_pr_rank_Pro <= g_pr_points[client] && g_pr_points[client] < g_pr_rank_Elite)
		Format(g_pr_rankname[client], 32, "PRO");
	else
	if (g_pr_rank_Elite <= g_pr_points[client] && g_pr_points[client] < g_pr_rank_Master)
		Format(g_pr_rankname[client], 32, "ELITE");		
	else
	if (g_pr_points[client] >= g_pr_rank_Master)
		Format(g_pr_rankname[client], 32, "MASTER");	
	CS_SetClientClanTag(client, g_pr_rankname[client]); 	
	
	if (oldrank)
	{
		if (!StrEqual(g_pr_rankname[client], old_pr_rankname, false))
		{
			PrintToChat(client,"%t","SkillGroup", MOSSGREEN, WHITE, GRAY,RED, g_pr_rankname[client]);
		}
	}
}

public Action:RespawnPlayer(Handle:Timer, any:client)
{
	new timeleft;
	if (timeleft>-2 && IsClientInGame(client) && !IsPlayerAlive(client) && (GetClientTeam(client) > 1) && !g_bSpectate[client] && g_bAutoRespawn)
		CS_RespawnPlayer(client);
}

public Action:RemoveGroundWeapons(Handle:timer)
{
	if (g_bPluginEnabled && g_bCleanWeapons)
	{
		new maxEntities = GetMaxEntities();
		decl String:class[20];
		
		for (new i = MaxClients + 1; i < maxEntities; i++)
		{
			if (IsValidEdict(i) && (GetEntDataEnt2(i, ownerOffset) == -1))
			{
				GetEdictClassname(i, class, sizeof(class));
				if ((StrContains(class, "weapon_") != -1) || (StrContains(class, "item_") != -1))
					AcceptEntityInput(i, "Kill");
			}
		}
	}
	return Plugin_Continue;
}

public Action:HideRadar(Handle:timer, any:client)
{
	if (IsValidEntity(client) && !IsFakeClient(client))
		SetEntProp(client, Prop_Send, "m_iHideHUD", HIDE_RADAR);
}

public Action:OpenMapTimes(Handle:timer, any:client)
{
	if (IsValidEntity(client) && IsClientInGame(client) && !IsFakeClient(client))
	{
		decl String:szSteamId[32];
		GetClientAuthString(client, szSteamId, 32);		
		db_viewRecord(client, szSteamId, g_szMapName);
	}
}

public Action:RefreshScoreboard(Handle:timer)
{
	if (g_bPluginEnabled)
	{
		for (new i = 1; i <= MaxClients; i++)
		{
			if (!IsClientInGame(i) || !IsValidEntity(i) || g_bPause[i]) continue;
			new Float:fltime = GetEngineTime() - g_fStartTime[i] - g_fPauseTime[i] + 1.0;
			if (IsPlayerAlive(i) && g_bTimeractivated[i])
			{
				new time = RoundToZero(fltime);
				Client_SetScore(i,time); 
				Client_SetAssists(i,g_OverallCp[i]);		
				Client_SetDeaths(i,g_OverallTp[i]);								
			}
			else
			{
			
				Client_SetScore(i,0);
				Client_SetDeaths(i,0);
				Client_SetAssists(i,0);
			}
		}
	}
	return Plugin_Continue;
}